Attribute VB_Name = "modFunctions"

Public Sub Bitmapheader()
 
'fill palette:
For r = 0 To 255
    With BMI.bmiColors(r)
                            .rgbBlue = r
                            .rgbGreen = r
                            .rgbRed = r
                            .rgbReserved = 0
    End With
Next r

 
 BMI.bmiHeader.biSize = 40 'the Bitmapheader-structure has a size of 40 Bytes
 BMI.bmiHeader.biWidth = bitSizeH  'have been set in the
 BMI.bmiHeader.biHeight = bitSizeV 'ImageOptions screen
 BMI.bmiHeader.biPlanes = 1
 BMI.bmiHeader.biBitCount = bitColors 'has been set in the ImageOptions screen
 BMI.bmiHeader.biCompression = BI_RGB
 BMI.bmiHeader.biSizeImage = 0
 BMI.bmiHeader.biXPelsPerMeter = 0
 BMI.bmiHeader.biYPelsPerMeter = 0
 BMI.bmiHeader.biClrUsed = 0 'bitColorsUsed '0 means that all colors are used
 BMI.bmiHeader.biClrImportant = 0 '0 means that all colors are of the same importance

'.biSizeImage, .biXPelsPerMeter and .biYPelsPerMeter
'are of no importance to StretchDIBits and can be set to 0
'.biPlanes should be set to 1
End Sub

'The most important part of it all:
'the StretchDIBits-function (a Windows API-function)
'that puts the image from memory into a Device Context,
'e.g. a window.
'Needed are the address in memory, the Device Context-handle (hDC),
'a Bitmapheader-structure (see above),
'and the size and coordinates of the image you wish to be copied.

Public Sub DisplayImage(frmDisplay As String)

'select window to be used:
If frmDisplay = "frmSingle" Then
        StretchhDC = frmSingle.hDC
        'adjust window size:
        frmSingle.Width = bitSizeH * Screen.TwipsPerPixelX
        frmSingle.Height = bitSizeV * Screen.TwipsPerPixelY
    ElseIf frmDisplay = "frmLive" Then
        StretchhDC = frmLive.hDC
        'adjust window size:
        frmLive.Width = bitSizeH * Screen.TwipsPerPixelX
        frmLive.Height = bitSizeV * Screen.TwipsPerPixelY
End If

'Set variables for StretchDIBits function:
StretchDestX = 0: StretchDestY = 0
StretchSrcX = 0: StretchSrcY = 0
StretchSrcWidth = CInt(bitSizeH)  'the BitSize variables have been
StretchSrcHeight = CInt(bitSizeV) ' set in the ImageOptions screen
StretchDestWidth = StretchSrcWidth
StretchDestHeight = StretchSrcHeight

  
'StretchDIBits function:
returnlines = StretchDIBits(StretchhDC, StretchDestX, _
StretchDestY, StretchDestWidth, StretchDestHeight, _
StretchSrcX, StretchSrcY, StretchSrcWidth, StretchSrcHeight, _
picAddress, BMI, DIB_RGB_COLORS, SRCCOPY)

If returnlines = 0 Then 'StretchDIBits returns the number of lines copied; 0 means an error has occurred
    MsgBox "error: StretchDIBits copied " & returnlines & " pixellines"
    stopFlag = True
End If



End Sub


Public Sub CheckErrors() 'checking for Grabber-DLL errornumbers
errorNumber = Get_Error

Select Case errorNumber
    Case 0
        Exit Sub
    Case 1
        MsgBox "can't find device number"
        Stop_Grabber (1)
        End
    Case 2
        MsgBox "register non-existent"
        Stop_Grabber (1)
        End
    Case 3
        MsgBox "initialisation failed"
        Stop_Grabber (1)
        End
    Case 4
        MsgBox "can't find grabber"
        Stop_Grabber (1)
        End
    Case 5
        MsgBox "unknown parameter"
        Stop_Grabber (1)
        End
    Case Else
        MsgBox "unexpected error...have fun!"
        Stop_Grabber (1)
        End
End Select


End Sub

